<div align="center">

  [![kinka](./logo.png)](https://www.npmjs.com/package/kinka) 

  [![](https://img.shields.io/badge/license-MIT-red.svg)](./LICENSE)
  [![](https://img.shields.io/npm/v/kinka.svg)](https://www.npmjs.com/package/kinka)
  [![](https://img.shields.io/travis/acacode/kinka.svg)](https://travis-ci.org/acacode/kinka)
  [![](https://www.codefactor.io/repository/github/acacode/kinka/badge/master)](https://www.codefactor.io/repository/github/acacode/kinka/overview/master)
  [![](https://img.shields.io/npm/dm/kinka.svg)](http://npm-stat.com/charts.html?package=kinka)
  [![](https://badgen.net/bundlephobia/min/kinka)](https://bundlephobia.com/result?p=kinka)
  [![](https://badgen.net/bundlephobia/minzip/kinka)](https://bundlephobia.com/result?p=kinka)

  <p>
    ⚡️ HTTP web client for browsers ⚡️
  </p>
</div>

**kinka** it is [most lighter 💨](https://bundlephobia.com/result?p=kinka) and very powerful JavaScript library designed for ajax requests!  
It will reduce your http code (which are using [XMLHttpRequests](https://developer.mozilla.org/en-US/docs/Web/API/XMLHttpRequest)) and allows do http code more simpler and easy to read.  

## 🚀 Installation

    $ npm i -S kinka
    # or using yarn
    $ yarn add kinka

## 📚 Documentation & Examples

[Documentation](./docs/documentation.md)  
[Examples](./test/examples)  
[Sandbox](https://jsfiddle.net/js2me/0y3ng8xu/)  

## Why kinka ❔

**It is the easiest way to catch your bad request**  
![catching error example](./docs/images/catchingErrors.png)  
**Many [powerful features 💪](./docs/documentation.md)(e.g. auto abortable requests) which can improve your interaction with your requests**  
![abortable key example](./docs/images/autoAbortableRequests.png)  
**Have [very small size](https://bundlephobia.com/result?p=kinka) which can improve site load time**  
![query params example](./docs/images/queryParams.png)  

## 👍 Contributing

If you want to help with the project, please refer to [guide for contribution](./CONTRIBUTING.md). It should contain most of the things you'll need to get your contribution started!  
Working on your first Pull Request? [Learn how to do it](https://egghead.io/courses/how-to-contribute-to-an-open-source-project-on-github)

## 📝 License

Licensed under the [MIT License](./LICENSE).
